#!/bin/bash

SS=`date +%s`

dt=`date +%H\\\\:%M\\\\:%S`


DoGraph()
{
# Parametri $1=DEV $2=start $3=step $4=titolo
if  [ $3 -eq 600 ]
then
	xg="--x-grid MINUTE:10:HOUR:1:HOUR:1:0:%H"
	hg=""
else
	xg=""
	hg="--height 400"
fi

[ $SS -eq 0 ] && echo "$1_$3"

rrdtool graph /var/www/mrtg/mplt_$1_$3.png \
	--end now --start $2 --width 640 $hg --step $3 \
	--title "$4" $xg \
	DEF:in_smtp=/var/stats/rrd/mplt_$DEV.rrd:in_smtp:AVERAGE \
	DEF:dout_smtp=/var/stats/rrd/mplt_$DEV.rrd:out_smtp:AVERAGE \
	DEF:in_ssh=/var/stats/rrd/mplt_$DEV.rrd:in_ssh:AVERAGE \
	DEF:dout_ssh=/var/stats/rrd/mplt_$DEV.rrd:out_ssh:AVERAGE \
	DEF:in_www=/var/stats/rrd/mplt_$DEV.rrd:in_www:AVERAGE \
	DEF:dout_www=/var/stats/rrd/mplt_$DEV.rrd:out_www:AVERAGE \
	DEF:in_vpn=/var/stats/rrd/mplt_$DEV.rrd:in_vpn:AVERAGE \
	DEF:dout_vpn=/var/stats/rrd/mplt_$DEV.rrd:out_vpn:AVERAGE \
	DEF:in_priv=/var/stats/rrd/mplt_$DEV.rrd:in_priv:AVERAGE \
	DEF:dout_priv=/var/stats/rrd/mplt_$DEV.rrd:out_priv:AVERAGE \
	DEF:in_oth=/var/stats/rrd/mplt_$DEV.rrd:in_UnClassified:AVERAGE \
	DEF:dout_oth=/var/stats/rrd/mplt_$DEV.rrd:out_UnClassified:AVERAGE \
	DEF:m_in_smtp=/var/stats/rrd/mplt_$DEV.rrd:in_smtp:MAX \
	DEF:dm_out_smtp=/var/stats/rrd/mplt_$DEV.rrd:out_smtp:MAX \
	DEF:m_in_ssh=/var/stats/rrd/mplt_$DEV.rrd:in_ssh:MAX \
	DEF:dm_out_ssh=/var/stats/rrd/mplt_$DEV.rrd:out_ssh:MAX \
	DEF:m_in_www=/var/stats/rrd/mplt_$DEV.rrd:in_www:MAX \
	DEF:dm_out_www=/var/stats/rrd/mplt_$DEV.rrd:out_www:MAX \
	DEF:m_in_vpn=/var/stats/rrd/mplt_$DEV.rrd:in_vpn:MAX \
	DEF:dm_out_vpn=/var/stats/rrd/mplt_$DEV.rrd:out_vpn:MAX \
	DEF:m_in_priv=/var/stats/rrd/mplt_$DEV.rrd:in_priv:MAX \
	DEF:dm_out_priv=/var/stats/rrd/mplt_$DEV.rrd:out_priv:MAX \
	DEF:m_in_oth=/var/stats/rrd/mplt_$DEV.rrd:in_UnClassified:MAX \
	DEF:dm_out_oth=/var/stats/rrd/mplt_$DEV.rrd:out_UnClassified:MAX \
	CDEF:out_smtp=dout_smtp,-1,\* \
	CDEF:out_ssh=dout_ssh,-1,\* \
	CDEF:out_www=dout_www,-1,\* \
	CDEF:out_vpn=dout_vpn,-1,\* \
	CDEF:out_priv=dout_priv,-1,\* \
	CDEF:out_oth=dout_oth,-1,\* \
	CDEF:m_out_smtp=dm_out_smtp,-1,\* \
	CDEF:m_out_ssh=dm_out_ssh,-1,\* \
	CDEF:m_out_www=dm_out_www,-1,\* \
	CDEF:m_out_vpn=dm_out_vpn,-1,\* \
	CDEF:m_out_priv=dm_out_priv,-1,\* \
	CDEF:m_out_oth=dm_out_oth,-1,\* \
	COMMENT:Valori\ in\ Bytes\ al\ secondo\\n \
	AREA:m_in_www\#ffa0a0:\
	AREA:m_in_smtp\#a0ffa0::STACK \
	AREA:m_in_vpn\#ffffa0::STACK \
	AREA:m_in_ssh\#a0ffff::STACK \
	AREA:m_in_priv\#a0a0ff::STACK \
	AREA:m_in_oth\#d0d0d0::STACK \
	AREA:m_out_www\#ffa0a0:\
	AREA:m_out_smtp\#a0ffa0::STACK \
	AREA:m_out_vpn\#ffffa0::STACK \
	AREA:m_out_ssh\#a0ffff::STACK \
	AREA:m_out_priv\#a0a0ff::STACK \
	AREA:m_out_oth\#d0d0d0::STACK \
	AREA:in_www\#ff0000:www \
	AREA:in_smtp\#00ff00:smtp:STACK \
	AREA:in_vpn\#ffff00:vpn:STACK \
	AREA:in_ssh\#00ffff:ssh:STACK \
	AREA:in_priv\#0000ff:priv:STACK \
	AREA:in_oth\#202020:other:STACK \
	AREA:out_www\#ff0000: \
	AREA:out_smtp\#00ff00::STACK \
	AREA:out_vpn\#ffff00::STACK \
	AREA:out_ssh\#00ffff::STACK \
	AREA:out_priv\#0000ff::STACK \
	AREA:out_oth\#202020::STACK \
	HRULE:0\#000000 \
	COMMENT:"$dt" \
	> /dev/null
}

[ "$TERM" != "dumb" ] &&  SS=0

for DEV in eth1 eth2
do
	DoGraph $DEV "now-36h" 600 "Giornaliero $DEV"

	let resto="$SS % 900"
	[ $resto -lt 100 ] && DoGraph $DEV "now-8d" 1800 "Settimanale $DEV"

	let resto="$SS % 7200"
	[ $resto -lt 100 ] && DoGraph $DEV "now-35d" 7200 "Mensile $DEV"

	let resto="$SS % 86400"
	[ $resto -lt 100 ] && DoGraph $DEV "now-400d" 86400 "Annuale $DEV"
done

exit 0
